<?php


/* ADD A FILTER FOR FEATURED IN PRODUCT LIST */
add_action( 'restrict_manage_posts', 'wpse45436_admin_posts_filter_restrict_manage_posts' );
/**
 * First create the dropdown
 * 
 * @author Ohad Raz
 * 
 * @return void
 */
function wpse45436_admin_posts_filter_restrict_manage_posts(){

    $type = 'post';
    if (isset($_GET['post_type'])) {
        $type = $_GET['post_type'];
    }

    //only add filter to post type you want
    if ('product' == $type) {
    // next hide the Yoast SEO Filters
?>
    <script type="text/javascript">
        jQuery(document).ready(function () {
			jQuery('label[for="wpseo-readability-filter"]').next().remove(); 
			jQuery('label[for="wpseo-filter"]').next().remove(); 
			jQuery('label[for="wpseo-readability-filter"]').remove(); 
			jQuery('label[for="wpseo-filter"]').remove(); 
        })
    </script>
<?php
        //change this to the list of values you want to show
        //in 'label' => 'value' format
        $values = array(
            __('Featured', 'woocommerce') . ': ' . __('Yes', 'woocommerce') => 'Yes', 
             __('Featured', 'woocommerce') . ': ' . __('No', 'woocommerce') => 'No',
        );
        ?>
        <select name="featured">
        <option value=""><?php echo( __('Filter by', 'woocommerce') . ' ' . strtolower(__('Featured', 'woocommerce'))) ; ?></option>
        <?php
            $current_v = isset($_GET['featured'])? $_GET['featured']:'';
            foreach ($values as $label => $value) {
                printf(
                        '<option value="%s"%s>%s</option>',
                        $value,
                        $value == $current_v? ' selected="selected"':'',
                        $label
                    );
                }
        ?>
        </select>
        <?php
    }
}
add_filter( 'parse_query', 'wpse45436_posts_filter' );
/**
 * if submitted filter by post meta
 * 
 * @author Ohad Raz
 * @param  (wp_query object) $query
 * 
 * @return Void
 */
function wpse45436_posts_filter( $query ){

    global $pagenow; /* It's a WP global */
    $type = 'post';
    if (isset($_GET['post_type'])) {
        $type = $_GET['post_type'];
    }
    if ( 'product' == $type && is_admin() && $pagenow=='edit.php' && isset($_GET['featured']) && $_GET['featured'] != '') {
    	$status = $_GET['featured'];
		if ($status == 'Yes') {
			$query->query_vars['tax_query'][] = array(
				'taxonomy' => 'product_visibility',
				'field' => 'slug',
				'terms' => 'featured'
			);
		} elseif ($status == 'No') {
			$query->query_vars['tax_query'][] = array(
				'taxonomy' => 'product_visibility',
				'field' => 'slug',
				'terms' => 'featured',
				'operator' => 'NOT IN'
			);
		}
    }
}


// ADD FIELDS AND CONTENT TO PRINTERS IN SHOP
add_action( 'add_meta_boxes', 'create_custom_meta_box' );
function create_custom_meta_box() {
    add_meta_box(
        'custom_product_meta_box',
        __( 'Product Details', 'woocommerce' ),
        'add_custom_content_meta_box',
        'product',
        'normal',
        'default'
    );
}

function add_custom_content_meta_box( $post ){
    ?>
    <style>
    .product_dtl_textarea1 {
        height: 50px !important;
    }
    .product_dtl_textarea2 {
        height: 150px !important;
    }
    </style>
    <div class="panel woocommerce_options_panel">
        <div class="options_group">
            <?php
            woocommerce_wp_text_input( array(
           		'id'          => '_product_color',
           		'label'       => __( 'Product Color', 'woocommerce' ),
           		'placeholder' => '',
           		'class'       => '',
           		'desc_tip'    => 'true',
           		'description' => __( 'Enter Product Color.', 'woocommerce' ),
            ));
            ?>
        </div>
        <div class="options_group">
            <?php
            woocommerce_wp_text_input( array(
           		'id'          => '_product_capacity',
           		'label'       => __( 'Product Capacity', 'woocommerce' ),
           		'placeholder' => '',
           		'class'       => '',
           		'desc_tip'    => 'true',
           		'description' => __( 'Enter Product Capacity.', 'woocommerce' ),
            ));
            ?>
        </div>
        <div class="options_group">
            <?php
            woocommerce_wp_text_input( array(
                'id'          => '_product_primary_key',
                'label'       => __( 'Primary Key', 'woocommerce' ),
                'placeholder' => '',
                'class'       => '',
                'desc_tip'    => 'true',
                'description' => __( 'Enter Primary Key.', 'woocommerce' ),
            ));
            ?>
        </div>
        <div class="options_group">
            <?php
            woocommerce_wp_textarea_input( array(
           		'id'          => '_product_alias_names',
           		'label'       => __( 'Product Alias Names', 'woocommerce' ),
           		'placeholder' => '',
           		'class'       => 'product_dtl_textarea1',
           		'desc_tip'    => 'true',
           		'description' => __( 'Enter comma separated Alias Names.', 'woocommerce' ),
            ));
            ?>
        </div>
        <div class="options_group">
            <?php
            woocommerce_wp_textarea_input( array(
           		'id'          => '_product_compatibility',
           		'label'       => __( 'Product Compatibility', 'woocommerce' ),
           		'placeholder' => '',
           		'class'       => 'product_dtl_textarea2',
           		'desc_tip'    => 'true',
           		'description' => __( 'Enter comma separated Values.', 'woocommerce' ),
            ));
            ?>
        </div>
    </div>
    <?php
}

add_action( 'woocommerce_process_product_meta', 'save_product_dtl_fields' );
function save_product_dtl_fields( $post_id ) {
    global $wpdb;

    if ( isset( $_POST['_product_color'] ) ) :
		update_post_meta( $post_id, '_product_color', sanitize_text_field( $_POST['_product_color'] ) );
	endif;
	if ( isset( $_POST['_product_capacity'] ) ) :
		update_post_meta( $post_id, '_product_capacity', sanitize_text_field( $_POST['_product_capacity'] ) );
	endif;
    if ( isset( $_POST['_product_primary_key'] ) ) :
        update_post_meta( $post_id, '_product_primary_key', sanitize_text_field( $_POST['_product_primary_key'] ) );
    endif;
	if ( isset( $_POST['_product_alias_names'] ) ) :
	    
	    $input = $_POST['_product_alias_names'];
	    $input_temp = array_map('strtoupper', explode(",",$input));
	    $word = get_the_title($post_id);
	    $words_ar = explode(" ",strtoupper($word));
        $combinations = array();
        $arr = getCombinations($words_ar);
        foreach($arr as $v){
        	$combination = implode(" ", $v);
        	if (!in_array($combination, $input_temp)) {
            	$combinations[] = $combination;
        	}
        }
        $final_ar = array_filter(array_merge($input_temp,$combinations));
        $final = implode(",", $final_ar);
	    
	    $wpdb->update( $wpdb->posts, array( '_product_alias_names' => $final),array('ID'=>$post_id));
	    update_post_meta( $post_id, '_product_alias_names', sanitize_text_field($final) );
	endif;
	if ( isset( $_POST['_product_compatibility'] ) ) :
		$wpdb->update( $wpdb->posts, array( '_product_compatibility' => $_POST['_product_compatibility']),array('ID'=>$post_id));
		update_post_meta( $post_id, '_product_compatibility', sanitize_text_field( $_POST['_product_compatibility'] ) );
		insert_printer($_POST['_product_compatibility']);
	endif;
}

function getCombinations($array) {
    $results = [[]];
    foreach ($array as $k => $element) {
        foreach ($results as $combination)
            $results[] =  $combination + [$k => $element];
    }
    return array_values(array_filter($results));
}

add_action('woocommerce_before_single_product', 'wp_extracode_for_products', 99);
function wp_extracode_for_products() {
    ?>
    <button type="button" class="btn btn-danger" onclick="go_back()">Retour</button>
    <br>
    <br>
    <script type="text/javascript">
        function go_back() {
            window.history.back();
        }
    </script>
    <?php
}

/*add_filter(
    "woocommerce_get_item_data",
    "product_details_display_on_cart",
    10,
    2
);

function product_details_display_on_cart($data, $cart_item)
{
    $product_id = $cart_item['product_id'];
    $color = get_post_meta($product_id,'_product_color',true);
    $capacity = get_post_meta($product_id,'_product_capacity',true);
    $data[] = [
        "name" => "Color",
        "value" => $color,
    ];
    $data[] = [
        "name" => "Capacity",
        "value" => $capacity,
    ];
    return $data;
}*/

function createPrinterPostType() {
    $labels = array(
        'name'               => _x( 'Printers', 'post type general name', 'stacy' ),
        'singular_name'      => _x( 'Printer', 'post type singular name', 'stacy' ),
        'menu_name'          => _x( 'Printers', 'admin menu', 'stacy' ),
        'name_admin_bar'     => _x( 'Printers', 'add new on admin bar', 'stacy' ),
        'add_new'            => _x( 'Add New', 'product', 'stacy' ),
        'add_new_item'       => __( 'Add New Printer', 'stacy' ),
        'new_item'           => __( 'New Printer', 'stacy' ),
        'edit_item'          => __( 'Edit Printer', 'stacy' ),
        'view_item'          => __( 'View Printer', 'stacy' ),
        'all_items'          => __( 'All Printers', 'stacy' ),
        'search_items'       => __( 'Search Printers', 'stacy' ),
        'not_found'          => __( 'No Printer found.', 'stacy' ),
        'not_found_in_trash' => __( 'No Printer found in Trash.', 'stacy' )
    );
   $args = array(
        'labels'             => $labels,
        'description'        => __( 'Description.', 'Add New Printer' ),
        'public'             => true,
        'publicly_queryable' => true,
        'show_ui'            => true,
        'show_in_menu'       => true,
        'query_var'          => true,
        'rewrite'            => array( 'slug' => 'printers' ),
        'has_archive'        => true,
        'hierarchical'       => false,
        'menu_position'      => 100,
        'menu_icon'          =>'dashicons-cart',
        'supports'           => array( 'title')
    );
    register_post_type( 'printers', $args );
}
add_action( 'init', 'createPrinterPostType' );

function alias_name_meta_box() {
    add_meta_box(
        '_printer_alias_name',
        __( 'Alias Name', 'sitepoint' ),
        'printer_alias_name_callback',
        'printers'
    );
}
add_action( 'add_meta_boxes', 'alias_name_meta_box' );
function printer_alias_name_callback() {
    ?>
    <style type="text/css">
        .printer_alias_name_textarea2 {
            height: 150px !important;
        }
    </style>
    <div class="panel woocommerce_options_panel">
        <div class="options_group">
            <?php
            woocommerce_wp_textarea_input( array(
                'id'          => '_printer_alias_name',
                'label'       => __( 'Printer Alias Names', 'woocommerce' ),
                'placeholder' => '',
                'class'       => 'printer_alias_name_textarea2',
                'desc_tip'    => 'true',
                'description' => __( 'Enter Printer Alias Names.', 'woocommerce' ),
            ));
            ?>
        </div>
    </div>
    <?php
}

add_action( 'save_post_printers', 'printers_on_save' );
function printers_on_save( $post_id) {
    if (isset($_POST['_printer_alias_name'])) {
        global $wpdb;
        
        $input = $_POST['_printer_alias_name'];
    	$input_temp = array_map('strtoupper', explode(",",$input));
    	    
        $title = get_the_title($post_id);
        $words_ar = explode(" ",strtoupper($title));
        $combinations = array();
        $arr = getCombinations($words_ar);
        foreach($arr as $v){
        	$combination = implode(" ", $v);
        	if (!in_array($combination, $input_temp)) {
            	$combinations[] = $combination;
        	}
        }
        $final_ar = array_filter(array_merge($input_temp,$combinations));
        $final = implode(",", $final_ar);
        
        $wpdb->delete( $wpdb->prefix.'printers', array( 'post_id' => $post_id ) );
        $wpdb->insert($wpdb->prefix.'printers',array('name' => $title, 'alias_name' => $final, 'post_id' => $post_id));
        update_post_meta($post_id, '_printer_alias_name', $final);
    }
}

//add_action('init','testing_fn');

function testing_fn(){
    if(isset($_GET['type']) && $_GET['type'] == 'iamdev'){
        $abc = 'CANON MG 7751 / CANON MG 7750 / CANON MG 7752 / CANON MG 7753 / CANON TS 8050 / CANON TS 8051 / CANON TS 8052 / CANON TS 8053 / CANON TS 9050 / CANON TS 9055 /';
        
        insert_printer($abc);
        exit();
    }
}

function insert_printer($comaptibility){
    global $wpdb;
    if (strpos($comaptibility, '/') !== false) {
        $printer_ar = explode("/", $comaptibility);
    } else{
        $printer_ar = explode(",", $comaptibility);
    }
	foreach($printer_ar as $printer){
	    if(!empty($printer)){
    		$title = ltrim($printer);
    		$title = rtrim($title);
            $query = $wpdb->prepare(
                'SELECT ID FROM '.$wpdb->posts.' WHERE post_title = %s
                AND post_type = \'printers\'',
                $title
            );
            $results = $wpdb->get_results('SELECT ID FROM '.$wpdb->posts.' WHERE post_title = "'.$title.'"
                AND post_type = "printers" ',ARRAY_A);
            
            if (is_array($results) && count($results) == 0) {
                
                $words_ar = explode(" ",strtoupper($title));
        		$combinations = array();
        		$arr = getCombinations($words_ar);
        		foreach($arr as $v){
        			$combinations[] = implode(" ", $v);
        			if(@count($v) > 1){
        				$combinations[] = implode("", $v);
        			}
        		}
        		$alias_name = implode(",", $combinations);
        		
                $new_post = array(
                    'post_title' => $title,
                    'post_content' => '',
                    'post_status' => 'publish',
                    'post_date' => date('Y-m-d H:i:s'),
                    'post_type' => 'printers'
                );
                $post_id = wp_insert_post($new_post);
                $wpdb->insert($wpdb->prefix.'printers',array('name' => $title, 'alias_name' => $alias_name, 'post_id' => $post_id));
                add_post_meta($post_id, '_printer_alias_name', $alias_name);
            }
	    }
	}
}
add_action('init','product_uploading');
function product_uploading(){
    if(@$_GET['iamdev']=="ok")
    {
        global $wpdb;
    	$s=0;
    	if (($open = fopen(get_template_directory()."/main_file_upload.csv", "r")) !== FALSE) 
    	{
    
    		while (($data = fgetcsv($open, 50000, ",")) !== FALSE) 
    		{   
    			if($s>0 && $s<750) 
    			{
    				$array[] = $data;
    			}    
    			$s++;

    		}
    
    		fclose($open);
    	}
    	
    	foreach($array as $val)
    	{
    		$title 			= $val[1];
    		$color 			= $val[6];
    		$cat_name 		= $val[4];
    		$capacity 		= $val[7];
    		$prim_key 		= $val[2];
    		$comaptibility 	= $val[11];
    		
    		$regular_price	= trim(str_replace('CHF','',$val[8]));
    		$special_price	= trim(str_replace('CHF','',$val[9]));
    		
    		$delivery_cost	= trim(str_replace('CHF','',$val[10]));
    		$marque			= $val[5];
    
    		$word = $title;
    		$words_ar = explode(" ",strtoupper($word));
    		$combinations = array();
    		$arr = getCombinations($words_ar);
    		foreach($arr as $v){
    			$combinations[] = implode(" ", $v);
    			if(@count($v) > 1){
    				$combinations[] = implode("", $v);
    			}
    		}
    		$alias_name = implode(",", $combinations);
            
            insert_printer($comaptibility);
    		$comaptibility_real = $comaptibility;
    		$comaptibility = str_replace("/",",",$comaptibility);
    		$page_slug = str_replace(" ","-",$title); // Slug of the Post
    
    		$new_page = array(
    		    'post_type'     => 'product',
    		    'post_title'    => $title,
    		    'post_content'  => $comaptibility_real,
    		    'post_status'   => 'publish',
    		    'post_author'   => 1,
    		    'post_name'     => $page_slug
    		);
    		$new_page_id = wp_insert_post($new_page);
			$wpdb->update( $wpdb->posts, array( '_product_alias_names' => $alias_name,'_product_compatibility' => $comaptibility),array('ID'=>$new_page_id));
			update_post_meta( $new_page_id, '_product_color', $color );
            update_post_meta( $new_page_id, '_product_capacity', $capacity );
            update_post_meta( $new_page_id, '_product_primary_key', $prim_key );
            update_post_meta( $new_page_id, '_product_alias_names', $alias_name );
            update_post_meta( $new_page_id, '_product_compatibility', $comaptibility );
            update_post_meta( $new_page_id, '_visibility', 'visible' );
            update_post_meta( $new_page_id, '_stock_status', 'instock');
            update_post_meta( $new_page_id, '_price', $regular_price );
            update_post_meta( $new_page_id, '_regular_price', $regular_price );
            update_post_meta( $new_page_id, '_sale_price', $special_price );
            update_post_meta( $new_page_id, '_manage_stock', 'no' );
            update_post_meta( $new_page_id, '_backorders', 'no' );
            update_post_meta( $new_page_id, 'delivery_cost', $delivery_cost );
            update_post_meta( $new_page_id, 'marque', $marque );
			
			set_post_thumbnail( $new_page_id,"2262");
			
			$categories = array($cat_name);
			wp_set_object_terms( $new_page_id, $categories ,'product_cat');
    
    	}
    
        exit();	
    }
    
}
